CON

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

VAR  
  long Raw_heading                                      
  long Correct_heading
  long loop
  long deg

OBJ

   HM55B :       "HM55B Compass Module Asm"
   Calibration : "HM55B Compass Calibration"
   'vp:          "Conduit"
   Num:          "simple_numbers"
   Host:         "simple_serial"

PUB Compass
  'vp.share(@heading,@deg)

  'host.init(RX,TX,baud)
  'host.init(26,27,1200)
  host.init(31,30,1200)
  'HM55B.start(Enable,Clock,Data) 
  'HM55B.start(21,22,20)
  HM55B.start(0,1,2)

repeat
    
    Raw_heading := HM55B.theta
    Correct_heading := Calibration.Correct(Raw_heading)

    'deg :=(Raw_heading*45)/1024                        '<--- Not Calibrated
    deg :=(Correct_heading*45)/1024                    '<--- Calibrated
    
    'host.str(num.dec(Raw_heading))                     '<--- Read this value during calibration
    host.str(num.dec(deg))
    
    pause1ms(1000)
    

PUB Pause1ms(Period)|ClkCycles 
{{Pause execution for Period (in units of 1 ms).}}

  ClkCycles := ((clkfreq / 1000 * Period) - 4296) #> 381     'Calculate 1 ms time unit
  waitcnt(ClkCycles + cnt)                                   'Wait for designated time 